From ed5edf005c47d28a91affca7273dc0cec6426440 Mon Sep 17 00:00:00 2001
From: Thomas JUND <tjund@entrouvert.com>
Date: Thu, 11 Feb 2021 12:56:05 +0100
Subject: [PATCH] fonts: add baloo Tammudu 2 (#51029)

---
 README                                         |   5 +++++
 .../balootammudu2-bold-webfont.woff            | Bin 0 -> 38532 bytes
 .../balootammudu2-bold-webfont.woff2           | Bin 0 -> 30440 bytes
 .../balootammudu2-extrabold-webfont.woff       | Bin 0 -> 37088 bytes
 .../balootammudu2-extrabold-webfont.woff2      | Bin 0 -> 29208 bytes
 .../balootammudu2-medium-webfont.woff          | Bin 0 -> 39008 bytes
 .../balootammudu2-medium-webfont.woff2         | Bin 0 -> 30604 bytes
 .../balootammudu2-regular-webfont.woff         | Bin 0 -> 38384 bytes
 .../balootammudu2-regular-webfont.woff2        | Bin 0 -> 30292 bytes
 .../balootammudu2-semibold-webfont.woff        | Bin 0 -> 38768 bytes
 .../balootammudu2-semibold-webfont.woff2       | Bin 0 -> 30592 bytes
 static/includes/fonts/_balootammudu2.scss      |  17 +++++++++++++++++
 12 files changed, 22 insertions(+)
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff2
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff2
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff2
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff2
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff
 create mode 100644 static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff2
 create mode 100644 static/includes/fonts/_balootammudu2.scss

diff --git a/README b/README
index 3e44a45f..de4b8f15 100644
--- a/README
+++ b/README
@@ -309,6 +309,11 @@ copyright notices:
   #
   # https://github.com/impallari/DancingScript
 
+* Baloo Tammudu 2
+  # Baloo 2 is Copyright (c) 2019 Ek Type (www.ektype.in)
+  # Licensed under the SIL Open Font License 1.1 (http://scripts.sil.org/OFL).
+  #
+  # https://github.com/EkType/Baloo2
 ~~~~
 
 Some theme variant files have their own specific licenses; refer to
diff --git a/static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff b/static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..7d18c3e4c15168009e856f113e2146e2c0b252a8
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff2 b/static/fonts/balooTammudu2/balootammudu2-bold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..5a4edb5b130fb0640277ad68bb51a9e29e37728c
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff b/static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..4dfc781fb7ce97b1015a6d098db408e6d476e93d
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff2 b/static/fonts/balooTammudu2/balootammudu2-extrabold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..57bb925bcfda3898795b952fe17105b8c31522b8
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff b/static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..67fde0734cde574efd353260336e8a85c28048c6
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff2 b/static/fonts/balooTammudu2/balootammudu2-medium-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..e33ad2b0fb01ab6babbf22b6b770bce257f6495a
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff b/static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..52b79bfb1b9331c6115cbe05ed71cfdf9d5e8d18
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff2 b/static/fonts/balooTammudu2/balootammudu2-regular-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..8ab8301dd3c445ed9029f7ef7359656fe7113580
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff b/static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff
new file mode 100644
index 0000000000000000000000000000000000000000..ae0b89944cb76a4329b0e5563e40caba7b715e26
GIT binary patch
diff --git a/static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff2 b/static/fonts/balooTammudu2/balootammudu2-semibold-webfont.woff2
new file mode 100644
index 0000000000000000000000000000000000000000..d16b5c645d63de7b6bcb6e3bef93bb6877bc674e
GIT binary patch
diff --git a/static/includes/fonts/_balootammudu2.scss b/static/includes/fonts/_balootammudu2.scss
new file mode 100644
index 00000000..5171d5f4
--- /dev/null
+++ b/static/includes/fonts/_balootammudu2.scss
@@ -0,0 +1,17 @@
+/* baloo-tammudu-2 latin-ext + latin */
+
+@mixin baloo-tammudu-font($type, $weight) {
+	@font-face {
+	  font-family: 'Baloo Tammudu 2';
+	  font-style: normal;
+	  font-weight: $weight;
+	  src: url('/static/fonts/balooTammudu2/balootammudu2-#{$type}-webfont.woff2') format('woff2'),
+	       url('/static/fonts/balooTammudu2/balootammudu2-#{$type}-webfont.woff') format('woff');
+	}
+}
+
+@include baloo-tammudu-font('regular', 400);
+@include baloo-tammudu-font('medium', 500);
+@include baloo-tammudu-font('semibold', 600);
+@include baloo-tammudu-font('bold', 700);
+@include baloo-tammudu-font('extrabold', 800);
\ No newline at end of file
-- 
2.20.1